/*
 * Copyright Staffan Gimåker 2006-2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#include <stdexcept>
#include "Action.hh"


using namespace peekabot;


Action::Action()
    : m_timestamp(
          boost::posix_time::microsec_clock::local_time())
{
}


Action::~Action() throw()
{
}


void Action::timestamp() throw()
{
    m_timestamp = boost::posix_time::microsec_clock::local_time();
}


void Action::set_timestamp(const Timestamp &timestamp) throw()
{
    m_timestamp = timestamp;
}


const Timestamp &Action::get_timestamp() const throw()
{
    return m_timestamp;
}


void Action::execute(ServerExecutionContext *context) const
{
    throw std::runtime_error(
        "This action's server-side execute() is not defined.");
}


void Action::execute(ClientExecutionContext *context) const
{
    throw std::runtime_error(
        "This action's proxy-side execute() is not defined.");
}



