/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_BUMPER_HH
#define __PEEKABOT_BUMPER_HH


#include <stdexcept>
#include <map>

#include "Sensor.hh"
#include "Types.hh"


namespace peekabot
{
    class SceneObject;

    
    class Bumper : public Sensor
    {
    public:
        Bumper() throw();
        
        virtual void interpret_sensor_data(
            SensorObject *sensor,
            DeserializationInterface &sensor_data) throw(std::exception);

        virtual void validate_params();

    private:
        void enable_bumper(SceneObject *obj) throw();

        void disable_bumper(SceneObject *obj) throw();

    private:
        bool m_prev_state;

        typedef std::map<SceneObject *, RGBColor> OverrideMap;

        OverrideMap m_overriden;
    };

}


#endif // __PEEKABOT_BUMPER_HH
