/*
 * Copyright Staffan Gimåker 2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_MATRIX_IO_HH
#define __PEEKABOT_MATRIX_IO_HH


#include "Matrix.hh"
#include "VectorIO.hh"


namespace peekabot
{
    template<class T>
    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const Matrix4<T> &x)
    {
        ar << x.m_cols;
        return ar;
    }

    template<class T>
    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, Matrix4<T> &x)
    {
        ar >> x.m_cols;
        return ar;
    }
}


#endif // __PEEKABOT_MATRIX_IO_HH
