/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "SensorFactory.hh"
#include "Sensor.hh"
#include "Rangefinder.hh"
#include "Bumper.hh"


using namespace peekabot;


Sensor *SensorFactory::instantiate_interpreter(const std::string &sensor_type) 
    const throw(std::exception)
{
    if( sensor_type == "rangefinder" )
        return new Rangefinder();
    else if( sensor_type == "bumper" )
        return new Bumper();
    else
    {
        // TODO: Add code for loading scripts here

        throw std::runtime_error(
            "No interpreter found for sensor type '" + sensor_type + "'");
    }
}
