/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_SENSOR_FACTORY_HH
#define __PEEKABOT_SENSOR_FACTORY_HH


#include <string>
#include <map>
#include <stdexcept>

#include "Singleton.hh"


namespace peekabot
{
    class Sensor;

    
    class SensorFactory
    {
    public:
        Sensor *instantiate_interpreter(const std::string &sensor_type) const throw(std::exception);

    private:
        bool add_sensor(const std::string &sensor_type, Sensor *sensor) throw();

        //Sensor *load_sensor_script(const std::string &script_file) throw();
    };


    typedef Singleton<SensorFactory> TheSensorFactory;

}


#endif // __PEEKABOT_SENSOR_FACTORY_HH
