/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __PEEKABOT_SNAPSHOT_WRITER_HH
#define __PEEKABOT_SNAPSHOT_WRITER_HH


#include <string>

#include "renderer/FrameCollector.hh"


namespace peekabot
{

    class SnapshotWriter : public renderer::FrameCollector
    {
    public:
        SnapshotWriter(
            const std::string &filename);
        
        virtual ~SnapshotWriter() throw();

        virtual void collect_frame(int w, int h, const uint8_t *rgb_data) throw();

    private:
        const std::string m_filename;
    };
    

}


#endif // __PEEKABOT_SNAPSHOT_WRITER_HH
