/*
 * Copyright Staffan Gimåker 2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_TYPES_IO_HH
#define __PEEKABOT_TYPES_IO_HH


#include "Types.hh"
#include "serialization/DeserializationInterface.hh"
#include "serialization/SerializationInterface.hh"


namespace peekabot
{
    inline SerializationInterface &operator<<(SerializationInterface &ar, const RGBColor &x)
    {
        ar << x.r << x.g << x.b;
        return ar;
    }

    inline DeserializationInterface &operator>>(DeserializationInterface &ar, RGBColor &x)
    {
        ar >> x.r >> x.g >> x.b;
        return ar;
    }

    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const RGBAColor &x)
    {
        ar << x.r << x.g << x.b << x.a;
        return ar;
    }

    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, RGBAColor &x)
    {
        ar >> x.r >> x.g >> x.b >> x.a;
        return ar;
    }

    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const Opacity &x)
    {
        ar << x.is_absolute << x.opacity;
        return ar;
    }

    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, Opacity &x)
    {
        ar >> x.is_absolute >> x.opacity;
        return ar;
    }
}


#endif // __PEEKABOT_TYPES_IO_HH
