/*
 * Copyright Staffan Gimåker 2006-2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_VECTOR_IO_HH
#define __PEEKABOT_VECTOR_IO_HH


#include "Vector.hh"
#include "serialization/DeserializationInterface.hh"
#include "serialization/SerializationInterface.hh"


namespace peekabot
{
    template<class T>
    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const Vector3<T> &x)
    {
        ar << x.m_c;
        return ar;
    }

    template<class T>
    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, Vector3<T> &x)
    {
        ar >> x.m_c;
        return ar;
    }


    template<class T>
    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const Vector4<T> &x)
    {
        ar << x.m_c;
        return ar;
    }

    template<class T>
    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, Vector4<T> &x)
    {
        ar >> x.m_c;
        return ar;
    }

    template<class T>
    inline SerializationInterface &operator<<(
        SerializationInterface &ar, const Vector2<T> &x)
    {
        ar << x.m_c;
        return ar;
    }

    template<class T>
    inline DeserializationInterface &operator>>(
        DeserializationInterface &ar, Vector2<T> &x)
    {
        ar >> x.m_c;
        return ar;
    }
}


#endif // __PEEKABOT_VECTOR_IO_HH
