/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_PAN_CAMERA_HH_INCLUDED
#define PEEKABOT_PAN_CAMERA_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class PanCamera : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        PanCamera(ObjectID target,
                  real_unit delta_x,
                  real_unit delta_y) throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        PanCamera() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID  m_target;
        real_unit m_delta_x;
        real_unit m_delta_y;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 5


#endif // PEEKABOT_PAN_CAMERA_HH_INCLUDED
