/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_COLOR_HH_INCLUDED
#define PEEKABOT_SET_COLOR_HH_INCLUDED


#include <string>
#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetColor : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetColor(ObjectID target_id,
                 RGBColor color,
                 bool recursive) throw();

        virtual ~SetColor() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext* context) 
            const throw(std::exception);

    private:
        SetColor() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        RGBColor m_color;
        bool m_recursive;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 17


#endif // PEEKABOT_SET_COLOR_HH_INCLUDED
