/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_GRID_CENTRAL_ANGLE_HH_INCLUDED
#define PEEKABOT_SET_GRID_CENTRAL_ANGLE_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SceneObject;

    class SetGridCentralAngle : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetGridCentralAngle(ObjectID target_id, float central_angle) throw();

        virtual ~SetGridCentralAngle() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetGridCentralAngle() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        float m_central_angle;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 82


#endif // PEEKABOT_SET_GRID_CENTRAL_ANGLE_HH_INCLUDED
