/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_GRID_SEGMENTS_HH_INCLUDED
#define PEEKABOT_SET_GRID_SEGMENTS_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SceneObject;

    class SetGridSegments : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetGridSegments(ObjectID target_id, uint32_t segment_count) throw();

        virtual ~SetGridSegments() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetGridSegments() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        uint32_t m_segment_count;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 80


#endif // PEEKABOT_SET_GRID_SEGMENTS_HH_INCLUDED
