/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_GRID_TYPE_HH_INCLUDED
#define PEEKABOT_SET_GRID_TYPE_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SceneObject;

    class SetGridType : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetGridType(ObjectID target_id, GridType type) throw();

        virtual ~SetGridType() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetGridType() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        GridType m_type;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 81


#endif // PEEKABOT_SET_GRID_TYPE_HH_INCLUDED
