/*
 * Copyright Staffan Gimåker 2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_JOINT_MIN_HH_INCLUDED
#define PEEKABOT_SET_JOINT_MIN_HH_INCLUDED


#include <stdexcept>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    /**
     * \brief Set the value of the given joint.
     */
    class SetJointMin : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetJointMin(ObjectID id, float val) throw();

        virtual ~SetJointMin() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetJointMin() throw();

        SetJointMin(const SetJointMin &other) throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_id;

        float m_val;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 94


#endif // PEEKABOT_SET_JOINT_MIN_HH_INCLUDED
