/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_LABEL_ALIGNMENT_HH_INCLUDED
#define PEEKABOT_SET_LABEL_ALIGNMENT_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetLabelAlignment : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetLabelAlignment(ObjectID target_id, TextAlignment alignment) throw();

        virtual ~SetLabelAlignment() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetLabelAlignment() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        TextAlignment m_alignment;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 86


#endif // PEEKABOT_SET_LABEL_ALIGNMENT_HH_INCLUDED
