/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_LABEL_TEXT_HH_INCLUDED
#define PEEKABOT_SET_LABEL_TEXT_HH_INCLUDED


#include <string>
#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetLabelText : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetLabelText(ObjectID target_id, const std::string &text) throw();

        virtual ~SetLabelText() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetLabelText() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        std::string m_text;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 85


#endif // PEEKABOT_SET_LABEL_TEXT_HH_INCLUDED
