/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_LAYER_HH_INCLUDED
#define PEEKABOT_SET_LAYER_HH_INCLUDED


#include <string>
#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SceneObject;

    class SetLayer : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetLayer(ObjectID target_id, uint32_t layer, bool recursive) throw();

        virtual ~SetLayer() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        void set_recursively(SceneObject *ptr) const;

        SetLayer() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        uint32_t m_layer;
        bool m_recursive;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 15


#endif // PEEKABOT_SET_LAYER_HH_INCLUDED
