/*
 * Copyright Staffan Gimåker 2008-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_LINE_STYLE_HH_INCLUDED
#define PEEKABOT_SET_LINE_STYLE_HH_INCLUDED


#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetLineStyle : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetLineStyle(ObjectID target_id, LineStyle style, int factor) throw();

        virtual ~SetLineStyle() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context)
            const throw(std::exception);

    private:
        SetLineStyle() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        LineStyle m_style;
        uint32_t m_factor;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 26


#endif // PEEKABOT_SET_LINE_STYLE_HH_INCLUDED
