/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_NAME_HH_INCLUDED
#define PEEKABOT_SET_NAME_HH_INCLUDED


#include <string>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetName : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetName(ObjectID target, std::string name) throw();

        virtual ~SetName() throw() {}

        virtual Action *clone() const;

        virtual void execute(ServerExecutionContext *context) const;

    private:
        SetName() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target;
        std::string m_name;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 13


#endif // PEEKABOT_SET_NAME_HH_INCLUDED
