/*
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_OPACITY_HH_INCLUDED
#define PEEKABOT_SET_OPACITY_HH_INCLUDED


#include <string>
#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetOpacity : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetOpacity(ObjectID target_id, const Opacity &opacity) throw();

        virtual ~SetOpacity() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        SetOpacity() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        Opacity m_opacity;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 14


#endif // PEEKABOT_SET_OPACITY_HH_INCLUDED
