/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_ORTHOGRAPHIC_HH_INCLUDED
#define PEEKABOT_SET_ORTHOGRAPHIC_HH_INCLUDED


#include "../Types.hh"
#include "../Action.hh"
#include "../Matrix.hh"
#include "../Vector.hh"


namespace peekabot
{
    class SetOrthographic : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetOrthographic(ObjectID target, bool orthographic) throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        SetOrthographic() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target;
        bool m_orthographic;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 11


#endif // PEEKABOT_SET_ORTHOGRAPHIC_HH_INCLUDED
