/*
 * Copyright Staffan Gimåker 2006-2009.
 * Copyright Anders Boberg 2007.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_SCALE_HH_INCLUDED
#define PEEKABOT_SET_SCALE_HH_INCLUDED


#include <exception>
 
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetScale : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetScale(
            ObjectID id, real_unit x_scale, real_unit y_scale, real_unit z_scale,
            bool relative = false) 
            throw();

        virtual ~SetScale() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        SetScale() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID  m_id;
        real_unit m_x_scale;
        real_unit m_y_scale;
        real_unit m_z_scale;
        bool m_relative;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 22


#endif // PEEKABOT_SET_SCALE_HH_INCLUDED
