/*
 * Copyright Staffan Gimåker 2007-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_SENSOR_DATA_HH_INCLUDED
#define PEEKABOT_SET_SENSOR_DATA_HH_INCLUDED

 
#include "../Types.hh"
#include "../Action.hh"
#include "../ChunkedBuffer.hh"


namespace peekabot
{
    class SetSensorData : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetSensorData(
            ObjectID target, const ChunkedBuffer &data) throw();

        virtual ~SetSensorData() throw();

        virtual Action *clone() const;

        virtual void execute(ServerExecutionContext *context) const;

    private:
        SetSensorData() throw();

        SetSensorData(const SetSensorData &action) throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target;
        
        ChunkedBuffer m_data;

        // Only used when *receiving* data. Set in deserialize state.
        bool m_data_is_big_endian;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 40


#endif // PEEKABOT_SET_SENSOR_DATA_HH_INCLUDED
