/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_VISIBILITY_HH_INCLUDED
#define PEEKABOT_SET_VISIBILITY_HH_INCLUDED


#include <string>
#include <exception>
#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetVisibility : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetVisibility(ObjectID target_id, bool visible) throw();

        virtual ~SetVisibility() throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        SetVisibility() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID m_target_id;
        bool m_visible;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 16


#endif // PEEKABOT_SET_VISIBILITY_HH_INCLUDED
