/*
 * Copyright Anders Boberg 2006-2007.
 * Copyright Staffan Gimåker 2006-2009.
 *
 * ---
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef PEEKABOT_SET_ZOOM_DISTANCE_HH_INCLUDED
#define PEEKABOT_SET_ZOOM_DISTANCE_HH_INCLUDED


#include "../Types.hh"
#include "../Action.hh"


namespace peekabot
{
    class SetZoomDistance : public Action
    {
        PEEKABOT_SERIALIZABLE

    public:
        SetZoomDistance(ObjectID target, float zoom_distance, bool relative) throw();

        virtual Action *clone() const;

        virtual void execute(
            ServerExecutionContext *context) 
            const throw(std::exception);

    private:
        SetZoomDistance() throw();

    protected:
        virtual void save(SerializationInterface &ar) const;

        virtual void load(DeserializationInterface &ar);

    private:
        ObjectID  m_target;
        float m_zoom_distance;
        bool m_relative;
    };
}


// PEEKABOT_REGISTER_SERIALIZABLE 7


#endif // PEEKABOT_SET_ZOOM_DISTANCE_HH_INCLUDED
