/*
 * Copyright Staffan Gimåker 2006-2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_CLIENT_CLIENT_EXECUTION_CONTEXT_HH
#define __PEEKABOT_CLIENT_CLIENT_EXECUTION_CONTEXT_HH


#include <string>
#include <boost/any.hpp>

#include "Status.hh"
#include "../Types.hh"


namespace peekabot
{
    namespace client
    {
        class ClientImpl;
        
        class ClientExecutionContext
        {
        protected:
            ClientImpl *m_client;      
            
        public:
            ClientExecutionContext(ClientImpl *client) throw();
            
            void report_action_status(
                uint32_t request_id, 
                OperationOutcome outcome, 
                const std::string &error_msg) throw();
            
            void report_action_result(
                uint32_t request_id,
                const boost::any &result) throw();
            
        };
    }
}


#endif // __PEEKABOT_CLIENT_CLIENT_EXECUTION_CONTEXT_HH
