/*
 * Copyright Staffan Gimåker 2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_CLIENT_EXCEPTIONS_HH
#define __PEEKABOT_CLIENT_EXCEPTIONS_HH


#include <stdexcept>


namespace peekabot
{
    namespace client
    {
        class AuthenticationFailed : public std::runtime_error
        {
        public:
            AuthenticationFailed(const std::string &what)
                : std::runtime_error(what) {}
        };

        class HostResolveFailed : public std::runtime_error
        {
        public:
            HostResolveFailed(const std::string &what)
                : std::runtime_error(what) {}
        };

        class ConnectionRefused : public std::runtime_error
        {
        public:
            ConnectionRefused(const std::string &what)
                : std::runtime_error(what) {}
        };

        class AlreadyConnected : public std::runtime_error
        {
        public:
            AlreadyConnected(const std::string &what)
                : std::runtime_error(what) {}
        };
    }
}


#endif // __PEEKABOT_CLIENT_EXCEPTIONS_HH
