/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_GUI_CAMERA_TRIGGER_HH
#define __PEEKABOT_GUI_CAMERA_TRIGGER_HH

#include "../ObjectVisitor.hh"
#include "../Types.hh"

namespace peekabot
{
    class SceneObject;

    namespace gui
    {
        class ViewFrame;
        
        class CameraTrigger
        {
        public:
            CameraTrigger(ViewFrame* view_frame);

            ~CameraTrigger();

            void on_child_attached(SceneObject *object) throw();

            void on_detached(SceneObject *object) throw();

            void deregister_recursive(SceneObject *object) throw();

        private:
            void on_name_set(SceneObject *object) throw();
            
        private:
            /** \brief The ViewFrame that registered this camera trigger.
             */
            ViewFrame* m_view_frame;           
        };
    }
}

#endif //__PEEKABOT_GUI_CAMERA_TRIGGER_HH
