/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef   	__PEEKABOT_GUI_COLLAPSABLEGROUP_HH
# define   	__PEEKABOT_GUI_COLLAPSABLEGROUP_HH

#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>

class Fl_Button;

namespace peekabot
{
    namespace gui
    {

        
        class CollapsableGroup : public Fl_Group
        {
        public:
            CollapsableGroup(int x, int y, int w, int h, const char *l = 0);
            void set_open(bool open_group);
            bool is_open()
            {
                return m_open;
            }

        private:
            static void collapse_callback(Fl_Widget *w, void *data);
            
            Fl_Button *m_collapse_button;
            Fl_Box *m_frame;
            int m_original_h;
            bool m_fit;
            bool m_open;
        };
    }
}

#endif	    /* !__PEEKABOT_GUI_COLLAPSABLEGROUP_HH */
