/**
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_GUI_COMMAND_REPOSITORY_HH
#define __PEEKABOT_GUI_COMMAND_REPOSITORY_HH

#include <boost/function.hpp>
#include <map>

#include "GUITypes.hh"

namespace peekabot
{
    namespace gui
    {
        class CommandRepository
        {
        public:
            typedef boost::function<void (void)> NullaryCommand;
            
            CommandRepository();
            
            NullaryCommand &get_command(Command command) throw(std::runtime_error);

        private:
            typedef std::map<Command, NullaryCommand> CommandMap;
            
            CommandMap m_command_map;
        };
    }
}

#endif //__PEEKABOT_GUI_COMMAND_REPOSITORY_HH
