/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_GUI_GUI_TYPES_HH
#define __PEEKABOT_GUI_GUI_TYPES_HH

#include <FL/Fl.H>

namespace peekabot
{
    namespace gui
    {
        enum ManipulatorMode
        {
            NAVIGATE_MODE,
            MOVE_MODE,
            ROTATE_MODE,
            SCALE_MODE               
        };
        
        enum KeyboardButton
        {
            KEY_CTRL = FL_CTRL,
            KEY_ALT = FL_ALT,
            KEY_SHIFT = FL_SHIFT
        };
        
        enum MouseButton
        {
            MOUSE_LEFT_BUTTON = FL_LEFT_MOUSE,
            MOUSE_RIGHT_BUTTON = FL_RIGHT_MOUSE,
            MOUSE_MIDDLE_BUTTON = FL_MIDDLE_MOUSE
        };

        enum Command
        {
            CMD_LOAD_SCENE,
            CMD_LOAD_ROBOT,
            CMD_QUIT,
            CMD_ABOUT,
            CMD_ABORT,
            CMD_CLEAR_SELECTION,
            CMD_DELETE_OBJECT,
            CMD_FULLSCREEN,
            CMD_SET_NAVIGATION_MODE,
            CMD_SET_MOVE_MODE,
            CMD_SET_ROTATE_MODE,
            CMD_SET_SCALE_MODE,
            CMD_TOGGLE_MOVE_MODE,
            CMD_TOGGLE_ROTATE_MODE,
            CMD_TOGGLE_SCALE_MODE,
            CMD_SET_CAMERA_COORDINATES,
            CMD_SET_LOCAL_COORDINATES,
            CMD_SET_WORLD_COORDINATES,
            CMD_SET_PARENT_COORDINATES,
            CMD_TOGGLE_X_AXIS,
            CMD_TOGGLE_Y_AXIS,
            CMD_TOGGLE_Z_AXIS,
            CMD_SET_X_AXIS,
            CMD_SET_Y_AXIS,
            CMD_SET_Z_AXIS,
            CMD_SET_LOCAL_PIVOT,
            CMD_SET_PARENT_PIVOT,
            CMD_SET_WORLD_PIVOT,
            CMD_SET_AVERAGE_PIVOT,
        };
    }
}

#endif //__PEEKABOT_GUI_GUI_TYPES_HH
