/*
 * Copyright Anders Boberg 2006.
 * Copyright Staffan Gimåker 2007, 2009.
 *
 * ---
 *
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PEEKABOT_GUI_ICON_MANAGER_HH_INCLUDED
#define PEEKABOT_GUI_ICON_MANAGER_HH_INCLUDED

#include <map>
#include <string>

#include "../Singleton.hh"
#include "../FsToolbox.hh"

class Fl_Image;

namespace peekabot
{

namespace gui
{
    class IconManager
    {
    public:
        IconManager() throw();
        virtual ~IconManager() throw();

        Fl_Image* get_icon(std::string filename) throw();

        typedef std::map<std::string, Fl_Image*> ImageMap;

    private:
        ImageMap m_image_map;

        fs::path m_icon_dir;
    };

    typedef Singleton<IconManager> TheIconManager;


}

}

#endif //PEEKABOT_GUI_ICON_MANAGER_HH_INCLUDED
