/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_RENDERER_PRIMITIVES_AXIS_TRIPOD_HH
#define __PEEKABOT_RENDERER_PRIMITIVES_AXIS_TRIPOD_HH


#include "../Cullable.hh"
#include "../Renderable.hh"


namespace peekabot
{
namespace renderer
{
    namespace primitives
    {

        class AxisTripod : public Cullable, public Renderable
        {
        protected:
            virtual void calculate_bvs() throw();
           
        public:
            AxisTripod();

            virtual AxisTripod *clone() const throw();

            virtual void get_renderables(
                Camera *camera, EnumerationCallback callback) throw();

            virtual void render(RenderContext &context) throw();
        };


    }
}
}


#endif // __PEEKABOT_RENDERER_PRIMITIVES_AXIS_TRIPOD_HH
