/*
 * This file is part of peekabot.
 *
 * peekabot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * peekabot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH
#define __PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH


#include "../VertexBased.hh"
#include "../Cullable.hh"
#include "../Mesh.hh"


namespace peekabot
{
    namespace renderer
    {
        namespace primitives
        {
            class Polygon : public Cullable,
                            public VertexBased
            {
            public:
                Polygon();

                Polygon(const Polygon &x);

                virtual Polygon *clone() const throw();

                virtual void get_renderables(
                    Camera *camera, EnumerationCallback callback) throw();

                void set_vertices(const VertexBased::Vertices &vertices) throw();

                void add_vertices(const VertexBased::Vertices &vertices) throw();

                void get_vertices(VertexBased::Vertices &vertices) const throw();

            protected:
                virtual void calculate_bvs() throw();

                void calculate_bvs(const VertexBased::Vertices &vertices) throw();

            private:
                TriMesh m_mesh;
            };
        }
    }
}


#endif // __PEEKABOT_RENDERER_PRIMITIVES_POLYGON_HH
