/*
 * Copyright Staffan Gimåker 2008.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef __PEEKABOT_SERIALIZATION_PAIR_HH
#define __PEEKABOT_SERIALIZATION_PAIR_HH


#include <utility>

#include "SerializationInterface.hh"
#include "DeserializationInterface.hh"


namespace peekabot
{
    template<class U, class V>
    SerializationInterface &operator<<(
        SerializationInterface &ar, const std::pair<U, V> &x)
    {
        ar << x.first << x.second;
        return ar;
    }

    template<class U, class V>
    DeserializationInterface &operator>>(
        DeserializationInterface &ar, std::pair<U, V> &x)
    {
        ar >> x.first >> x.second;
        return ar;
    }
}


#endif // __PEEKABOT_SERIALIZATION_PAIR_HH
